#### Previous topic

scipy.signal.TransferFunction.to_zpk

#### Next topic

scipy.signal.ZerosPolesGain.A

# scipy.signal.ZerosPolesGain

class `scipy.signal.``ZerosPolesGain`(*system)

  Linear Time Invariant system class in zeros, poles, gain form.

  Represents the system as the transfer function \(H(s)=k \prod_i (s - z[i]) / \prod_j (s - p[j])\), where \(k\) is the `gain`, \(z\) are the `zeros` and \(p\) are the `poles`.

  Parameters:

  *system : arguments

  > The `ZerosPolesGain` class can be instantiated with 1 or 3 arguments. The following gives the number of input arguments and their interpretation:

  > > - 1: `lti` system: (`StateSpace`, `TransferFunction` or `ZerosPolesGain`)
  > > - 3: array_like: (zeros, poles, gain)

  See also

  `TransferFunction`, `StateSpace`, `lti`, `zpk2ss`, `zpk2tf`, `zpk2sos`

  Notes

  Changing the value of properties that are not part of the `ZerosPolesGain` system representation (such as the `A`, `B`, `C`, `D` state-space matrices) is very inefficient and may lead to numerical inaccuracies.

  Attributes

  `A` | State matrix of the `StateSpace` system.
  `B` | Input matrix of the `StateSpace` system.
  `C` | Output matrix of the `StateSpace` system.
  `D` | Feedthrough matrix of the `StateSpace` system.
  `den` | Denominator of the `TransferFunction` system.
  `gain` | Gain of the `ZerosPolesGain` system.
  `num` | Numerator of the `TransferFunction` system.
  `poles` | Poles of the `ZerosPolesGain` system.
  `zeros` | Zeros of the `ZerosPolesGain` system.

  Methods

  `bode`([w, n]) | Calculate Bode magnitude and phase data of a continuous-time system.
  `freqresp`([w, n]) | Calculate the frequency response of a continuous-time system.
  `impulse`([X0, T, N]) | Return the impulse response of a continuous-time system.
  `output`(U, T[, X0]) | Return the response of a continuous-time system to input U.
  `step`([X0, T, N]) | Return the step response of a continuous-time system.
  `to_ss`() | Convert system representation to `StateSpace`.
  `to_tf`() | Convert system representation to `TransferFunction`.
  `to_zpk`() | Return a copy of the current ‘ZerosPolesGain’ system.